import groovyx.gpars.ParallelEnhancer
import static groovyx.gpars.GParsPool.withPool

def names = ['Paul', 'Dierk', 'Jeff', 'Scott', 'Peter']

def printIt = { println it; Thread.sleep(1000) }

Time.code {
  names.each printIt  
}

ParallelEnhancer.enhanceInstance(names)

Time.code {
  names.eachParallel printIt
}


def anotherNames = ['Paul', 'Dierk', 'Jeff', 'Scott', 'Peter']

withPool {
  Time.code {
    anotherNames.makeConcurrent().each printIt
  }  

  anotherNames.makeSequential()

  Time.code {
    anotherNames.each printIt
  }
  
  Time.code {
    anotherNames.asConcurrent {
      anotherNames.each printIt
    }
  }

  Time.code {
    anotherNames.each printIt
  }
}
